/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2000
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef _DeviceDither
#define _DeviceDither

class DeviceDither
{
public:
   enum {
      DITHER_UNLISTED = -1
   };

   static DeviceDither        *createDitherInstance           (char        *pszDitherType,
                                                               Device      *pDevice,
                                                               char        *pszOptions);

   virtual void                ditherRGBtoCMYK                (PBITMAPINFO2 pbmi2,
                                                               PBYTE        pbStart) = 0;

   virtual bool                ditherAllPlanesBlank           () = 0;
   virtual bool                ditherCPlaneBlank              () = 0;
   virtual bool                ditherMPlaneBlank              () = 0;
   virtual bool                ditherYPlaneBlank              () = 0;
   virtual bool                ditherKPlaneBlank              () = 0;
   virtual bool                ditherLCPlaneBlank             () = 0;
   virtual bool                ditherLMPlaneBlank             () = 0;

   virtual void                newFrame                       () = 0;

   virtual BinaryData         *getCPlane                      () = 0;
   virtual BinaryData         *getMPlane                      () = 0;
   virtual BinaryData         *getYPlane                      () = 0;
   virtual BinaryData         *getKPlane                      () = 0;
   virtual BinaryData         *getLCPlane                     () = 0;
   virtual BinaryData         *getLMPlane                     () = 0;

   virtual char               *getID                          () = 0;
   char                       *getName                        ();

   static char                *getName                        (char        *pszId);

   static char                *IDToName                       (char        *pszId);
   static bool                 ditherNameValid                (char        *pszId);
   static bool                 ditherCatagoryValid            (char        *pszId);
   static char                *getDitherCatagory              (char        *pszId);

   static Enumeration         *getEnumeration                 ();
};

#endif
