#include "ComboBoxHandler.hpp"

using namespace Gtk;
using namespace JobDialog;

ComboBoxHandler* ComboBoxHandler::uniqueInstance = 0;

ComboBoxHandler* ComboBoxHandler:: instance()
{
	if(ComboBoxHandler::uniqueInstance == 0) 
		uniqueInstance=new ComboBoxHandler(); 
	
	return uniqueInstance;
}

bool ComboBoxHandler::populateValues(Widget* widget, DriverProperty *driverProperty)
{
	Combo *combo = safeDowncast(widget);
	
	if(combo == 0 ) 
		return false;
	
	combo->set_popdown_strings(driverProperty->getAvailableValues() );
	combo->get_entry()->set_text(driverProperty->getDefaultValue() );
	combo->get_entry()->set_sensitive(driverProperty->isEditable() );     // Disable the widget if not editable. 
	
	return true;
}

string ComboBoxHandler::getSelectedValue(Widget* widget)
{
	Combo *combo = safeDowncast(widget);
	
	if(combo == 0 ) 
		return "";    // Better throw 'WidgetMismatchException'

	return combo->get_entry()->get_text();	
}
	
inline Combo* ComboBoxHandler::safeDowncast(Widget * widget)
{
	if( ! Combo::isA(widget) ) 
		return 0;						// Need to throw 'WidgetMismatchException' here.
	
	return (Combo *) widget; 	 // it is a safe downcasting now ...
}	
