#ifndef		__DriverInfo_Cpp
   #define	__DriverInfo_Cpp

#include "Device.hpp"
#include "JobAPI.hpp"

#include <string.h>
#include <vector>
#include <glib.h>
#include <gmodule.h>


/**********************************************************/
class DriverInfo {
public:
	DriverInfo(){}
	void generateDriverInfo();
	vector<string> getDeviceList();
	int openDevice (char *);
	int closeDevice() {   return g_module_close (hmodDevice);}
	
	
	Driver getDriver() { return driver;}
protected:
	vector<string> listOrientations();
	vector<string> listForms();
	vector<string> listTrays();	
	vector<string> listMedias();	
	vector<string> listResolutions();	
	vector<string> listDithers();
	vector<string> listPrintModes();	
		
private:
   Device       *pDevice;
   PFNNEWDEVICE  pfnNewDevice;
   GModule      *hmodDevice;


	vector< DriverProperty> dps;
	Driver driver;
};

#endif
