#include<iostream>
#include<vector>
#include<map>

#include "JobAPI.hpp"

using namespace std;

DriverProperty::DriverProperty(string pn ,string dn,string wn, string* vec,int count, string def, bool b=true)
{
//	cout<<" >     DriverProperty::DriverProperty (....) "<<endl;
	
	editable = b;
	propertyName = pn;
	nameForDisplay = dn;
	widgetName = wn;
	for(int i=0;i<count;i++)
	{
		availableValues.push_back(vec[i]);
	}
	defaultValue = def;	
	
//	cout<<" <     DriverProperty::DriverProperty (....) "<<endl;
}

DriverProperty::
DriverProperty(string pn, string dn, string wn, vector<string> vals, string def, bool b=true)
{
	editable = b;
	propertyName = pn;
	nameForDisplay = dn;
	widgetName = wn;
	availableValues = vals;
	defaultValue = def;

	availableValues.erase(availableValues.begin() ); // remove the first one. Its a duplicate.

}

DriverProperty::DriverProperty(const DriverProperty& dp)
{
//	cout<<" >     DriverProperty::DriverProperty (const DP&) "<<endl;

	editable =dp.editable;
	propertyName = dp.propertyName;
	nameForDisplay = dp.nameForDisplay;
	widgetName = dp.widgetName;
	availableValues =dp.availableValues;
	defaultValue = dp.defaultValue;
	
//	cout<<" <     DriverProperty::DriverProperty (const DP&) "<<endl;
}

DriverProperty DriverProperty::operator =(DriverProperty dp)
{
	editable =dp.editable;
	propertyName = dp.propertyName;
	nameForDisplay = dp.nameForDisplay;
	widgetName = dp.widgetName;
	availableValues =dp.availableValues;
	defaultValue = dp.defaultValue;
	
	
	return *this;
}

DriverProperty::DriverProperty()
{
//		cout<<" >     DriverProperty::DriverProperty () "<<endl;
//			cout<<" <     DriverProperty::DriverProperty () "<<endl;
}

void DriverProperty::printMe()
{
//	cout<<" >     DriverProperty::printMe() "<<endl;
	cout<<"Property Name --> "<<propertyName << "      Display Name --> " <<nameForDisplay<<endl;
	cout <<"Widget Name --> "<<widgetName<<"       Editable -->" <<editable<<endl;
	cout<<"Default Value --> "<<defaultValue<< endl;
	cout<<"Available Property Values are: "<<endl;
	
	vector<string>::iterator itr;
	for(itr=availableValues.begin(); itr != availableValues.end(); itr++)
		cout<<"\t\t "<<*itr<<endl;
	
//	cout<<" <     DriverProperty::printMe() "<<endl;		
}

/*******************************************************************/

Driver::Driver(string s, DriverProperty **dpArr , int count)
{
//	cout<<" >     Driver::Driver(...) "<<endl;

	driverName =s;
	for(int i=0;i<count;i++)
	{
		availablePropertyNames.push_back(dpArr[i]->getName());
		theMap[dpArr[i]->getName()] = *dpArr[i];
	}

//	cout<<" <     DriverDriver(...) "<<endl;
}

Driver::
Driver (string s, vector<DriverProperty> dps)
{
	driverName = s;
	for(int i= 0; i< dps.size(); i++)
	{
		availablePropertyNames.push_back(dps[i].getName());
		theMap[availablePropertyNames[i]] = dps[i];
	}
}

void Driver::
printMe()
{
	for(int i=0;i<availablePropertyNames.size();i++)
	{
		cout<<endl<<"******************************************************"<<endl;
	
		theMap[availablePropertyNames[i]].printMe();
	
		cout<<"******************************************************"<<endl;
	}
}
