#ifndef _COM_IBM_LINUX_OMNI_JOB_JobAPIHpp
  #define  _COM_IBM_LINUX_OMNI_JOB_JobAPIHpp

#include<vector>
#include<map>
#include<string>

class DriverProperty {
public:
	bool 	isEditable() 								  { return editable;}
	string getName()   									{ return propertyName;}
	string 	getPropertyNameForDisplay() 	{ return nameForDisplay;}
	string 	getWidgetName()							{ return widgetName;}
	vector	<string> getAvailableValues()	 { return availableValues;}	
	string 	getDefaultValue()						  { return defaultValue;}
	bool 	setDefaultValue(string s)			  { defaultValue = s;}
	
	/**************************/
	// COPY CONSTRUCTOR needed for deep copy 			
	/*************************/
	
	DriverProperty(string,string,string, string*,int, string,bool=true);
	DriverProperty(string,string,string,vector<string>,string,bool=true);
	DriverProperty(const DriverProperty&);
	DriverProperty();
	DriverProperty operator =(DriverProperty);
	
	void printMe();
protected:
	bool editable;
	string propertyName;
	string nameForDisplay;
	string widgetName;	
	vector<string> availableValues ;
	string defaultValue;
};

class Driver {
public:
	string getName() 													{ return driverName;} 
	vector<string> getAvailablePropertyNames()		 { return availablePropertyNames;}
	DriverProperty getProperty(string s)					 {	return theMap.find(s)->second;}
	bool setProperty(string s, DriverProperty dp)		{   (*(theMap.find(s) ) ).second = dp; return true;}
	
	Driver(string, DriverProperty **, int);
	Driver(string, vector<DriverProperty>);
	Driver(void){}
	
	void printMe();
	/***********************************/
protected:
	string driverName;
	vector <string> availablePropertyNames;
	map<string, DriverProperty> theMap;
};
#endif


