#ifndef _COM_IBM_LINUX_OMNI_JOB_JobPropertyDialogControllerHpp
 #define  _COM_IBM_LINUX_OMNI_JOB_JobPropertyDialogControllerHpp

#include <vector>
#include<sigc++/object_slot.h>

#include "JobAPI.hpp"
#include "JobPropertyDialogView.hpp"

using namespace Gtk;

namespace JobDialog {

class JobPropertyDialogController : public SigC::Object
{
public:  
		/* Exposed to the client */
	JobPropertyDialogController(Driver d)  { driver = d; view = 0;}
	~JobPropertyDialogController();
	
	vector<string> getSelectedJobProperties();
	vector<string> getDefaultJobProperties();
	
public:
	void onSaveNprintButtonClicked();
	void onSaveButtonClicked();
	void onPrintButtonClicked();
	void onCancelButtonClicked();

protected:
	void setupDialog();
	Driver getSelectedDriver();
	JobPropertyDialogController() {view= 0;}

private:
	struct PropertyWidgetPair {
		Widget *widget;
		DriverProperty * driverProperty;
		string defaultValue;
	};
	
	Driver driver;
	JobPropertyDialogView *view;
	vector<PropertyWidgetPair> propertyWidgetList;	
	
};

}; // end of namespace

#endif
