#include "OmniGSInterface.h"
#include "JobAPI.hpp"
#include "DriverInfo.hpp"
#include "DriverSelectionDialog.hpp"
#include "JobPropertyDialogController.hpp"


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

#include <gtk--/main.h>



/***********************************************************/

int 
GetOmniJobProperties (int argc, char *argv[], char **s)
{
	
	Gtk::Kit kit(&argc,&argv);
	bool driverFound=false;

	
	DriverInfo df;
	vector<string> deviceList = df.getDeviceList();
	
	if(deviceList.size() < 1)
	{
		cerr<<"\nSorry. No drivers found."<<endl;
		cerr<<"Make sure that LD_LIBARAY_PATH is pointing to the directory where drivers are placed.\n\n";
		return 0;
	}       	

	DriverSelectionDialog ds;
	string drivername = ds.selectDriver(deviceList);

	if( 0 == df.openDevice((char *)("lib"+drivername+".so").c_str()) )
	{
		df.generateDriverInfo();
		df.closeDevice();
		driverFound = true;
	}		
	
	if(!driverFound)
	{
		cerr<<endl<<"The driver < "<<drivername<<" > was not found"<<endl;
		cerr<<"Choose a valid driver name.\n "	<<endl;
		return 0;
	}
	
	JobDialog::JobPropertyDialogController controller(df.getDriver());
	vector<string> jobprops = controller.getSelectedJobProperties();
	
	*s[0]=0;
	
	for(int ijob=0;ijob<jobprops.size();ijob++)
	{
		strcat(*s,jobprops[ijob].c_str() );
		strcat(*s," ");	
	}

//	*s+strlen(*s)-1=0;

   return 0;
}
