#include "TextBoxHandler.hpp"

using namespace Gtk;
using namespace JobDialog;

TextBoxHandler* TextBoxHandler::uniqueInstance = 0; 		// static member initialization.

TextBoxHandler* TextBoxHandler:: instance()
{
	if(uniqueInstance == 0) 
		uniqueInstance=new TextBoxHandler(); 
	
	return uniqueInstance;
}

bool TextBoxHandler::populateValues(Widget* widget, DriverProperty *driverProperty)
{
	Entry *entry = safeDowncast(widget);
	
	if(entry == 0 ) 
		return false;
	
	// There will be only one value hence the getAvailableValues and getDefaultValue 
	// both should return the same value.
	
	entry->set_text(driverProperty->getDefaultValue() );
	entry->set_sensitive(driverProperty->isEditable() );     // Disable the widget if not editable. 
	
}

string TextBoxHandler::getSelectedValue(Widget* widget)
{
	Entry *entry = safeDowncast(widget);
	
	if(entry == 0 ) 
		return "";    // Better throw 'WidgetMismatchException'
	
	return entry->get_text();	
}
	
inline Entry* TextBoxHandler::safeDowncast(Widget * widget)
{
	if( ! Entry::isA(widget) ) 
		return 0;						// Might need to throw 'WidgetMismatchException' here.
	
	return (Entry *) widget; 	 // it is a safe downcasting now ...
}	
