/*
 *   IBM Omni driver
 *   Copyright (c) International Business Machines Corp., 2000
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published
 *   by the Free Software Foundation; either version 2.1 of the License, or
 *   (at your option) any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
 *   the GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public License
 *   along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */
#ifndef _PluggableBlitter
#define _PluggableBlitter

#include "DeviceBlitter.hpp"

class PluggableBlitter : public DeviceBlitter
{
public:
                   PluggableBlitter               (Device                  *pDevice,
                                                   char                    *pszLibraryName,
                                                   char                    *pszType);
   virtual        ~PluggableBlitter               ();

   void            initializeInstance             ();

   virtual bool    rasterize                      (PBYTE                    pbBits,
                                                   PBITMAPINFO2             pbmi,
                                                   PRECTL                   prectlPageLocation,
                                                   BITBLT_TYPE              eType);

   virtual string  toString                       (ostrstream&              oss);
   friend ostream& operator<<                     (ostream&                 os,
                                                   const PluggableBlitter& device);

private:
   bool            monoRasterize                  (PBYTE                    pbBits,
                                                   PBITMAPINFO2             pbmi,
                                                   PRECTL                   prectlPageLocation,
                                                   BITBLT_TYPE              eType);
   bool            colorRasterize                 (PBYTE                    pbBits,
                                                   PBITMAPINFO2             pbmi,
                                                   PRECTL                   prectlPageLocation,
                                                   BITBLT_TYPE              eType);

   bool            fHaveInitialized_d;
};

#endif
