#
# IBM Omni driver
# Copyright (c) International Business Machines Corp., 2000
#
# This library is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published
# by the Free Software Foundation; either version 2.1 of the License, or
# (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See
# the GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this library; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
#

# Stuff you change
# DEBUG                 = 1
XML_DIRECTORY	      = $(CURDIR)/../xml4c3_1_0-linux
DEVHELPERFILES        = ../BinaryData.o \
                        ../HardCopyCap.o \
                        ../DeviceBlitter.o \
                        ../DeviceCommand.o \
                        ../DeviceConnection.o \
                        ../DeviceForm.o \
			../DeviceGamma.o \
                        ../DeviceInstance.o \
                        ../DeviceMedia.o \
			../DeviceOrientation.o \
                        ../DevicePrintMode.o \
                        ../DeviceResolution.o \
                        ../DeviceTray.o \
                        ../Device.o \
			../StringResource.o \
			../StringResourceEn.o \
			../hppcl3/bitmap.o \
			../hppcl3/CMYKbitmap.o \
                        ../GplCompression.o \
                        ../GplDitherInstance.o \
			../PDL.o
LIBRARYNAME	      = omni

# Stuff you don't
SUBDIRS               = $(SUBDIRSLIST:~=.make)   # Win95 nmake bug - doesnt like dir names, had to add .make extension
CLEANSUBDIRS          = $(SUBDIRSLIST:~=.clean)
CC                    = c++
ifneq ($(strip $(DEBUG)),)
DEBUG                 = debug=1
RETAIL                =
else
DEBUG                 =
RETAIL                = retail=1
endif
CFLAGS                = -Wall -I .. -I . -I ../hppcl3
ifneq ($(strip $(DEBUG)),)
CFLAGS               += -g -DDEBUG=1
else
CFLAGS               += -O3
endif
CFLAGS               += -fPIC -rdynamic
CFLAGS               += $(shell glib-config --cflags gmodule)
LFLAGS                = -L $(OMNI_LIB_PATH) -l$(LIBRARYNAME) $(shell glib-config --libs gmodule)

include $(OMNI_PATH)/version.mak

.SUFFIXES:
.SUFFIXES: .cpp .hpp .o .exe

.cpp.o:
	$(CC) $(CFLAGS) -c $(*F).cpp

ifeq ($(origin DEVICENAME), undefined)
notall:    # This should not be called by itself!
endif

# make version
ifeq "$(windir)" ""
LD_LIBRARY_PATH = $(CURDIR)/..:$(XML_DIRECTORY)/lib
else
LD_LIBRARY_PATH = $(CURDIR)/..;$(XML_DIRECTORY)/lib
endif
export LD_LIBRARY_PATH

lib$(DEVICENAME).so:	$(DEVCFILES:~=.o) Makefile
	$(CC) -shared -Wl,-soname,$@ -o $@ $(DEVCFILES:~=.o)
ifdef retail
	strip $@
endif
